//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//#define MAGICMA  20050610

//extern int magic  = 20130321;

extern double Lots               = 0.1;
extern double MaximumRisk        = 0.02;
extern double DecreaseFactor     = 100;
extern double MovingPeriod       = 12;
extern double MovingShift        = 6;
extern double Slipage            = 100;
extern int TP = 3000;
extern int SL = 300;
extern string Comment_TimeFrame = "";
datetime Time0;  
int MAGICMA;// = 0000015+Period();
int limit = 2;

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
  MAGICMA = 0000015+Period();
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<0.1) lot=0.1;
   return(Lots);
  }
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double ma;
   int    res;
//---- go trading only for first tiks of new bar
 if(Volume[0]>1) return;
//---- get Moving Average 

   int    counted_bars=IndicatorCounted();
//----

double Adaptive1H_1_0 = iCustom (NULL,60,"adaptive Gann High-Low activator jma Heiken Ashi arrows-1_2.0",60,0.0,1,4,5,false,1.0,false,true,true,false,false,true,"",false,White,9,"",0,1);
double Adaptive1H_1_1 = iCustom (NULL,60,"adaptive Gann High-Low activator jma Heiken Ashi arrows-1_2.0",60,0.0,1,4,5,false,1.0,false,true,true,false,false,true,"",false,White,9,"",1,1);

double Adaptive1H_2_0 = iCustom (NULL,60,"adaptive Gann High-Low activator jma Heiken Ashi arrows-1_2.0",60,0.0,1,4,5,false,1.0,false,true,true,false,false,true,"",false,White,9,"",0,2);
double Adaptive1H_2_1 = iCustom (NULL,60,"adaptive Gann High-Low activator jma Heiken Ashi arrows-1_2.0",60,0.0,1,4,5,false,1.0,false,true,true,false,false,true,"",false,White,9,"",1,2);

double Adaptive1H_3_0 = iCustom (NULL,60,"adaptive Gann High-Low activator jma Heiken Ashi arrows-1_2.0",60,0.0,1,4,5,false,1.0,false,true,true,false,false,true,"",false,White,9,"",0,3);
double Adaptive1H_3_1 = iCustom (NULL,60,"adaptive Gann High-Low activator jma Heiken Ashi arrows-1_2.0",60,0.0,1,4,5,false,1.0,false,true,true,false,false,true,"",false,White,9,"",1,3);

double EpreviousCandleClose1 = Close[1];    
double EpreviousCandleOpen1 = Open[1]; 

double EpreviousCandleClose2 = Close[2];    
double EpreviousCandleOpen2 = Open[2]; 


//---- sell conditions   

   if (EpreviousCandleOpen2>Adaptive1H_2_0 && EpreviousCandleClose1<Adaptive1H_1_0)    
   { Print (EpreviousCandleOpen2+" "+Adaptive1H_2_0+" "+EpreviousCandleClose1+" "+Adaptive1H_1_0+" ");
      res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,1,Bid+SL*Point,Bid-TP*Point,"Adaptive+Gann+15"+ Comment_TimeFrame,0000015+Period(),0,Red);
      return;
   }
//---- buy conditions
   

   if (EpreviousCandleOpen2<Adaptive1H_2_0 && EpreviousCandleClose1>Adaptive1H_1_0) 
   { Print (EpreviousCandleOpen2+" "+Adaptive1H_2_0+" "+EpreviousCandleClose1+" "+Adaptive1H_1_0+" ");
      res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,1,Ask-SL*Point,Ask+TP*Point,"Adaptive+Gann+15"+Comment_TimeFrame,0000015+Period(),0,Blue);
      return;
   }   
 
//----
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   int    res;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average 



//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      
      
      
//---- BUY      
      if(OrderType()==OP_BUY)
        {
 
   if (OrderProfit()==3000*Point)    
   {
         OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         break;
         }
        }
        
        
//---- SELL    
      if(OrderType()==OP_SELL)
        {
   
   if (OrderProfit()==3000*Point)
   {
         OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         break;
         }
        }
     }
//----
  }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
//----
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Hour check function                                                   |
//+------------------------------------------------------------------+
bool hourCheck()
{
		datetime time = CurTime();
		int hour = TimeHour(time);
			
			if( hour >= 0 && hour < 24 )
			{
			return(true);
     		}
			
} 
//+------------------------------------------------------------------+